# Imports
from os.path import join
from distutils.core import *
import glob


_tx_generator = Extension('_tx_generator',
                         sources = glob.glob('src-transactions/*.cpp'),
                         include_dirs=["src-transactions"],
                         depends=glob.glob('src-transactions/*.h')
                         )


_struct_generator = Extension('_struct_generator',
                         sources = glob.glob('src-struct/*.c'),
                         include_dirs=["src-struct"],
                         depends=glob.glob('src-struct/*.h')
                         )


setup(name='py_dataset',
      description='A Library to generate syntetic structured datasets with taxonomies',
      author="Vincenzo D'Elia",
      author_email='vincenzo.delia@polito.it',
      version='0.1',
      packages=['dataset_generation'],
      ext_package='dataset_generation',
      ext_modules=[_tx_generator, _struct_generator],
     )
