
#include "global.h"
#include "functions.h"
 
/* If you decide to use noise, fix GRP2 onwards */
 
#define GRP0 ((r_behavior > noise) ? 0 : 1)
#define GRP1 ((r_behavior > noise) ? 1 : 0)
#define GRP2 ((r_behavior > noise) ? 2 : 0)
#define GRP3 ((r_behavior > noise) ? 3 : 0)
#define GRP4 ((r_behavior > noise) ? 4 : 0)
 
 
LINT pred0(DOUBLE noise,
           DOUBLE salary,
           DOUBLE commission,
           LINT age,
           LINT car_model,
           LINT ed_level,
           LINT town,
           LINT homeyears,
           DOUBLE houseval,
           DOUBLE equity,
           DOUBLE loan
           )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    group = GRP0;
 
  else if (40 <= age && age < 60)
    group = GRP1;
 
  else
    group = GRP0;
 
  return (group);
}
 
 
LINT pred1(DOUBLE noise,
           DOUBLE salary,
           DOUBLE commission,
           LINT age,
           LINT car_model,
           LINT ed_level,
           LINT town,
           LINT homeyears,
           DOUBLE houseval,
           DOUBLE equity,
           DOUBLE loan
           )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (50000 <= salary && salary <= 100000)
      group = GRP0;
    else
      group = GRP1;
 
  else if (40 <= age && age < 60)
    if (75000 <= salary && salary <= 125000)
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (25000 <= salary && salary <= 75000)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
LINT pred2(DOUBLE noise,
           DOUBLE salary,
           DOUBLE commission,
           LINT age,
           LINT car_model,
           LINT ed_level,
           LINT town,
           LINT homeyears,
           DOUBLE houseval,
           DOUBLE equity,
           DOUBLE loan
           )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (ed_level == 0 || ed_level == 1)
      group = GRP0;
    else
      group = GRP1;
 
  else if (40 <= age && age < 60)
    if (ed_level == 1 || ed_level == 2 || ed_level == 3 )
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (ed_level == 2 || ed_level == 3 || ed_level == 4)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
LINT pred3(DOUBLE noise,
           DOUBLE salary,
           DOUBLE commission,
           LINT age,
           LINT car_model,
           LINT ed_level,
           LINT town,
           LINT homeyears,
           DOUBLE houseval,
           DOUBLE equity,
           DOUBLE loan
           )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (ed_level == 0 || ed_level == 1)
      if (25000 <= salary && salary <= 75000)
        group = GRP0;
      else
        group = GRP1;
    else
      if (50000 <= salary && salary <= 100000)
        group = GRP0;
      else
        group = GRP1;
 
  else if (40 <= age && age < 60)
    if (ed_level == 1 || ed_level == 2 || ed_level == 3 )
      if (50000 <= salary && salary <= 100000)
        group = GRP0;
      else
        group = GRP1;
    else
      if (75000 <= salary && salary <= 125000)
        group = GRP0;
      else
        group = GRP1;
 
  else
    if (ed_level == 2 || ed_level == 3 || ed_level == 4)
      if (50000 <= salary && salary <= 100000)
        group = GRP0;
      else
        group = GRP1;
    else
      if (25000 <= salary && salary <= 75000)
        group = GRP0;
      else
        group = GRP1;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *    (2*(salary+commission)/3 - ed_level*5000 - 20000);
 */
LINT pred4(DOUBLE noise,
           DOUBLE salary,
           DOUBLE commission,
           LINT age,
           LINT car_model,
           LINT ed_level,
           LINT town,
           LINT homeyears,
           DOUBLE houseval,
           DOUBLE equity,
           DOUBLE loan
           )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*(salary+commission)/3 - ed_level*5000 - 20000);
  behav = disposable;
 
  if (behav > 0)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *    (2*(salary+commission)/3 - ed_level*5000 - loan/5 - 10000);
 */
LINT pred5(DOUBLE noise,
           DOUBLE salary,
           DOUBLE commission,
           LINT age,
           LINT car_model,
           LINT ed_level,
           LINT town,
           LINT homeyears,
           DOUBLE houseval,
           DOUBLE equity,
           DOUBLE loan
           )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - ed_level*5000 - loan/5 - 10000);
  behav = disposable;
 
  if (behav > 0)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}
 
 
LINT pred6(DOUBLE noise,
           DOUBLE salary,
           DOUBLE commission,
           LINT age,
           LINT car_model,
           LINT ed_level,
           LINT town,
           LINT homeyears,
           DOUBLE houseval,
           DOUBLE equity,
           DOUBLE loan
           )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  if (age < 40)
    if (50000 <= total_salary && total_salary <= 100000)
      group = GRP0;
    else
      group = GRP1;
 
  else if (40 <= age && age < 60)
    if (75000 <= total_salary && total_salary <= 125000)
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (25000 <= total_salary && total_salary <= 75000)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *   (2*(salary+commission)/3 - loan/5 - ed_level*5000 + equity/5 - 10000);
 */
LINT pred7(DOUBLE noise,
           DOUBLE salary,
           DOUBLE commission,
           LINT age,
           LINT car_model,
           LINT ed_level,
           LINT town,
           LINT homeyears,
           DOUBLE houseval,
           DOUBLE equity,
           DOUBLE loan
           )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - loan/5 - ed_level*5000 + equity/5 - 10000);
  behav = disposable;
 
  if (behav > 0)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}
 
 
LINT pred8(DOUBLE noise,
           DOUBLE salary,
           DOUBLE commission,
           LINT age,
           LINT car_model,
           LINT ed_level,
           LINT town,
           LINT homeyears,
           DOUBLE houseval,
           DOUBLE equity,
           DOUBLE loan
           )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (60000 <= salary)
      group = GRP0;
    else
      group = GRP1;
 
  else if (40 <= age && age < 60)
    if (80000 <= salary)
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (40000 <= salary)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *        ((salary+commission)/3 - 30000);
 */
LINT pred9(DOUBLE noise,
           DOUBLE salary,
           DOUBLE commission,
           LINT age,
           LINT car_model,
           LINT ed_level,
           LINT town,
           LINT homeyears,
           DOUBLE houseval,
           DOUBLE equity,
           DOUBLE loan
           )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (total_salary/3 - 30000);
  behav = disposable;
 
  if (behav > 0)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}
 
 
LINT pred10(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (ed_level == 0 || ed_level == 1)
      group = GRP0;
    else
      group = GRP1;
 
  else if (40 <= age && age < 60)
    if (ed_level == 0 || ed_level == 1 || ed_level == 2 || ed_level == 3)
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (ed_level == 0)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income = 0.7 * (Salary + Commission)
 *                     (Age-75) * 100 + Equity/10
 *                     - #Child*7500 - Loan/5 + Car_Model*1000
 */
LINT pred11(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (0.7*total_salary + 100.0*(age-75) + equity/10.0 -
     ed_level*7500 - loan/5.0  + car_model*1000);
 
  behav = disposable/312500;
 
  if (behav > 0.15)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}
 
 
/* Two groups */
LINT pred20(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    group = GRP0;
 
  else if (40 <= age && age < 60)
    group = GRP1;
 
  else
    group = GRP0;
 
  return (group);
}
 
LINT pred21(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (50000 <= salary && salary <= 100000)
      group = GRP0;
    else
      group = GRP1;
 
  else if (40 <= age && age < 60)
    if (75000 <= salary && salary <= 125000)
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (25000 <= salary && salary <= 75000)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
LINT pred22(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (ed_level == 0 || ed_level == 1)
      group = GRP0;
    else
      group = GRP1;
 
  else if (40 <= age && age < 60)
    if (ed_level == 1 || ed_level == 2 || ed_level == 3 )
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (ed_level == 2 || ed_level == 3 || ed_level == 4)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
LINT pred23(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (ed_level == 0 || ed_level == 1)
      if (25000 <= salary && salary <= 75000)
        group = GRP0;
      else
        group = GRP1;
    else
      if (50000 <= salary && salary <= 100000)
        group = GRP0;
      else
        group = GRP1;
 
  else if (40 <= age && age < 60)
    if (ed_level == 1 || ed_level == 2 || ed_level == 3 )
      if (50000 <= salary && salary <= 100000)
        group = GRP0;
      else
        group = GRP1;
    else
      if (75000 <= salary && salary <= 125000)
        group = GRP0;
      else
        group = GRP1;
 
  else
    if (ed_level == 2 || ed_level == 3 || ed_level == 4)
      if (50000 <= salary && salary <= 100000)
        group = GRP0;
      else
        group = GRP1;
    else
      if (25000 <= salary && salary <= 75000)
        group = GRP0;
      else
        group = GRP1;
 
  return (group);
}
 
 
LINT pred24(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (50000 <= salary && salary <= 100000)
      if (100000 <= loan && loan <= 300000)
        group = GRP0;
      else
        group = GRP1;
    else
      if (200000 <= loan && loan <= 400000)
        group = GRP0;
      else
        group = GRP1;
 
  else if (40 <= age && age < 60)
    if (75000 <= salary && salary <= 125000)
      if (200000 <= loan && loan <= 400000)
        group = GRP0;
      else
        group = GRP1;
    else
      if (300000 <= loan && loan <= 500000)
        group = GRP0;
      else
        group = GRP1;
 
  else
    if (25000 <= salary && salary <= 75000)
      if (300000 <= loan && loan <= 500000)
        group = GRP0;
      else
        group = GRP1;
    else
      if (100000 <= loan && loan <= 300000)
        group = GRP0;
      else
        group = GRP1;
 
  return (group);
}
 
 
LINT pred25(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  if (age < 40)
    if (50000 <= total_salary && total_salary <= 100000)
      group = GRP0;
    else
      group = GRP1;
 
  else if (40 <= age && age < 60)
    if (75000 <= total_salary && total_salary <= 125000)
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (25000 <= total_salary && total_salary <= 75000)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *    (2*(salary+commission)/3 - loan/5 - 20000);
 */
LINT pred26(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - loan/5 - 20000);
  behav = disposable;
 
  if (behav > 0)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *    (2*(salary+commission)/3 - ed_level*5000 - 20000);
 */
LINT pred27(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*(salary+commission)/3 - ed_level*5000 - 20000);
  behav = disposable;
 
  if (behav > 0)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *    (2*(salary+commission)/3 - ed_level*5000 - loan/5 - 10000);
 */
LINT pred28(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - ed_level*5000 - loan/5 - 10000);
  behav = disposable;
 
  if (behav > 0)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *   (2*(salary+commission)/3 - ed_level*5000 + equity/5 - 10000);
 */
LINT pred29(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - loan/5 + equity/5 - 10000);
  behav = disposable;
 
  if (behav > 0)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *   (2*(salary+commission)/3 - loan/5 - ed_level*5000 + equity/5 - 10000);
 */
LINT pred60(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - loan/5 - ed_level*5000 + equity/5 - 10000);
  behav = disposable;
 
  if (behav > 0)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}
 
 
/* Three groups */
 
LINT pred30(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    group = GRP0;
  else if (age < 60)
    group = GRP1;
  else
    group = GRP2;
 
  return (group);
}
 
 
LINT pred31(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (50000 <= salary && salary <= 75000)
      group = GRP0;
    else if (75000 <= salary && salary <= 100000)
      group = GRP1;
    else
      group = GRP2;
 
  else if (40 <= age && age < 60)
    if (75000 <= salary && salary <= 100000)
      group = GRP0;
    else if (100000 <= salary && salary <= 125000)
      group = GRP1;
    else
      group = GRP2;
 
  else
    if (25000 <= salary && salary <= 50000)
      group = GRP0;
    else if (50000 <= salary && salary <= 75000)
      group = GRP1;
    else
      group = GRP2;
 
  return (group);
}
 
 
LINT pred32(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (ed_level == 0)
      group = GRP0;
    else if (ed_level == 1 || ed_level == 2)
      group = GRP1;
    else
      group = GRP2;
 
  else if (40 <= age && age < 60)
    if (ed_level == 1 || ed_level == 2)
      group = GRP0;
    else if (ed_level == 3 || ed_level == 4)
      group = GRP1;
    else
      group = GRP2;
 
  else
    if (ed_level == 3 || ed_level == 4)
      group = GRP0;
    else if (ed_level == 0)
      group = GRP1;
    else
      group = GRP2;
 
  return (group);
}
 
 
LINT pred33(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (ed_level == 0 || ed_level == 1)
      if (60000 <= salary && salary < 90000)
        group = GRP0;
      else if (90000 <= salary && salary < 120000)
        group = GRP1;
      else
        group = GRP2;
    else
      if (90000 <= salary && salary < 120000)
        group = GRP0;
      else if (60000 <= salary && salary < 90000)
        group = GRP1;
      else
        group = GRP2;
 
  else if (40 <= age && age < 60)
    if (ed_level == 1 || ed_level == 2 || ed_level == 3 )
      if (90000 <= salary && salary < 120000)
        group = GRP0;
      else if (60000 <= salary && salary < 90000)
        group = GRP1;
      else
        group = GRP2;
    else
      if (60000 <= salary && salary < 90000)
        group = GRP0;
      else if (90000 <= salary && salary < 120000)
        group = GRP1;
      else
        group = GRP2;
 
  else
    if (ed_level == 2 || ed_level == 3 || ed_level == 4)
      if (50000 <= salary && salary < 80000)
        group = GRP0;
      else if (80000 <= salary && salary < 110000)
        group = GRP1;
      else
        group = GRP2;
    else
      if (80000 <= salary && salary < 110000)
        group = GRP0;
      else if (50000 <= salary && salary < 80000)
        group = GRP1;
      else
        group = GRP2;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *    (2*(salary+commission)/3 - ed_level*5000 - 10000);
 */
LINT pred34(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - ed_level*5000 - 20000);
  behav = disposable;
 
  if (behav > 15000)
    group = GRP0;
  else if (behav > 0)
    group = GRP1;
  else
    group = GRP2;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *    (2*(salary+commission)/3 - ed_level*5000 - loan/5 - 10000);
 */
LINT pred35(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - ed_level*5000 - loan/5 - 10000);
  behav = disposable;
 
  if (behav > 15000)
    group = GRP0;
  else if (behav > 0)
    group = GRP1;
  else
    group = GRP2;
 
  return (group);
}
 
 
LINT pred36(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  if (age < 40)
    if (50000 <= total_salary && total_salary <= 75000)
      group = GRP0;
    else if (75000 <= total_salary && total_salary <= 100000)
      group = GRP1;
    else
      group = GRP2;
 
  else if (40 <= age && age < 60)
    if (75000 <= total_salary && total_salary <= 100000)
      group = GRP0;
    else if (100000 <= total_salary && total_salary <= 125000)
      group = GRP1;
    else
      group = GRP2;
 
  else
    if (25000 <= total_salary && total_salary <= 50000)
      group = GRP0;
    else if (50000 <= total_salary && total_salary <= 75000)
      group = GRP1;
    else
      group = GRP2;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *   (2*(salary+commission)/3 - loan/5 - ed_level*5000 + equity/5 - 10000);
 */
LINT pred37(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - loan/5 - ed_level*5000 + equity/5 - 10000);
  behav = disposable;
 
  if (behav > 15000)
    group = GRP0;
  else if (behav > 0)
    group = GRP1;
  else
    group = GRP2;
 
  return (group);
}
 
 
/* Four groups */
 
LINT pred40(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 35)
    group = GRP0;
  else if (age < 50)
    group = GRP1;
  else if (age < 65)
    group = GRP2;
  else
    group = GRP3;
 
  return (group);
}
 
 
LINT pred41(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (50000 <= salary && salary <= 80000)
      group = GRP0;
    else if (80000 <= salary && salary <= 110000)
      group = GRP1;
    else if (110000 <= salary && salary <= 140000)
      group = GRP2;
    else
      group = GRP3;
 
  else if (40 <= age && age < 60)
    if (80000 <= salary && salary <= 110000)
      group = GRP0;
    else if (110000 <= salary && salary <= 140000)
      group = GRP1;
    else if (50000 <= salary && salary <= 80000)
      group = GRP2;
    else
      group = GRP3;
 
  else
    if (110000 <= salary && salary <= 140000)
      group = GRP0;
    else if (50000 <= salary && salary <= 80000)
      group = GRP1;
    else if (80000 <= salary && salary <= 110000)
      group = GRP2;
    else
      group = GRP3;
 
  return (group);
}
 
 
LINT pred42(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (ed_level == 0)
      group = GRP0;
    else if (ed_level == 1 || ed_level == 2)
      group = GRP1;
    else if (ed_level == 3)
      group = GRP2;
    else
      group = GRP3;
 
  else if (40 <= age && age < 60)
    if (ed_level == 1 || ed_level == 2)
      group = GRP0;
    else if (ed_level == 3)
      group = GRP1;
    else if (ed_level == 4)
      group = GRP2;
    else
      group = GRP3;
 
  else
    if (ed_level == 3)
      group = GRP0;
    else if (ed_level == 4)
      group = GRP1;
    else if (ed_level == 0 || ed_level == 1)
      group = GRP2;
    else
      group = GRP3;
 
  return (group);
}
 
 
LINT pred43(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (ed_level == 0 || ed_level == 1)
      if (50000 <= salary && salary < 80000)
        group = GRP0;
      else if (80000 <= salary && salary < 110000)
        group = GRP1;
      else if (110000 <= salary && salary < 140000)
        group = GRP2;
      else
        group = GRP3;
    else
      if (80000 <= salary && salary < 110000)
        group = GRP0;
      else if (110000 <= salary && salary < 140000)
        group = GRP1;
      else if (50000 <= salary && salary < 80000)
        group = GRP2;
      else
        group = GRP3;
 
  else if (40 <= age && age < 60)
    if (ed_level == 1 || ed_level == 2 || ed_level == 3 )
      if (110000 <= salary && salary < 140000)
        group = GRP0;
      else if (50000 <= salary && salary < 80000)
        group = GRP1;
      else if (80000 <= salary && salary < 110000)
        group = GRP2;
      else
        group = GRP3;
    else
      if (80000 <= salary && salary < 110000)
        group = GRP0;
      else if (50000 <= salary && salary < 80000)
        group = GRP1;
      else if (110000 <= salary && salary < 140000)
        group = GRP2;
      else
        group = GRP3;
 
  else
    if (ed_level == 2 || ed_level == 3 || ed_level == 4)
      if (20000 <= salary && salary < 60000)
        group = GRP0;
      else if (60000 <= salary && salary < 90000)
        group = GRP1;
      else if (90000 <= salary && salary < 120000)
        group = GRP2;
      else
        group = GRP3;
    else
      if (60000 <= salary && salary < 90000)
        group = GRP0;
      else if (90000 <= salary && salary < 120000)
        group = GRP1;
      else if (20000 <= salary && salary < 60000)
        group = GRP2;
      else
        group = GRP3;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *    (2*(salary+commission)/3 - ed_level*5000 - 10000);
 */
LINT pred44(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - ed_level*5000 - 20000);
  behav = disposable;
 
  if (behav > 30000)
    group = GRP0;
  else if (behav > 15000)
    group = GRP1;
  else if (behav > 0)
    group = GRP2;
  else
    group = GRP3;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *    (2*(salary+commission)/3 - ed_level*5000 - loan/5 - 10000);
 */
LINT pred45(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - ed_level*5000 - loan/5 - 10000);
  behav = disposable;
 
  if (behav > 30000)
    group = GRP0;
  else if (behav > 15000)
    group = GRP1;
  else if (behav > 0)
    group = GRP2;
  else
    group = GRP3;
 
  return (group);
}
 
 
LINT pred46(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  if (age < 40)
    if (50000 <= total_salary && total_salary <= 80000)
      group = GRP0;
    else if (80000 <= total_salary && total_salary <= 110000)
      group = GRP1;
    else if (110000 <= total_salary && total_salary <= 140000)
      group = GRP2;
    else
      group = GRP3;
 
  else if (40 <= age && age < 60)
    if (80000 <= total_salary && total_salary <= 110000)
      group = GRP0;
    else if (110000 <= total_salary && total_salary <= 140000)
      group = GRP1;
    else if (50000 <= total_salary && total_salary <= 80000)
      group = GRP2;
    else
      group = GRP3;
 
  else
    if (110000 <= total_salary && total_salary <= 140000)
      group = GRP0;
    else if (50000 <= total_salary && total_salary <= 80000)
      group = GRP1;
    else if (80000 <= total_salary && total_salary <= 110000)
      group = GRP2;
    else
      group = GRP3;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *   (2*(salary+commission)/3 - loan/5 - ed_level*5000 + equity/5 - 10000);
 */
LINT pred47(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - loan/5 - ed_level*5000 + equity/5 - 10000);
  behav = disposable;
 
  if (behav > 30000)
    group = GRP0;
  else if (behav > 15000)
    group = GRP1;
  else if (behav > 0)
    group = GRP2;
  else
    group = GRP3;
 
  return (group);
}
 
 
/* Five groups */
 
LINT pred50(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 32)
    group = GRP0;
  else if (age < 44)
    group = GRP1;
  else if (age < 56)
    group = GRP2;
  else if (age < 68)
    group = GRP3;
  else
    group = GRP4;
 
  return (group);
}
 
 
LINT pred51(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (50000 <= salary && salary <= 75000)
      group = GRP0;
    else if (75000 <= salary && salary <= 100000)
      group = GRP1;
    else if (100000 <= salary && salary <= 125000)
      group = GRP2;
    else if (125000 <= salary && salary <= 150000)
      group = GRP3;
    else
      group = GRP4;
 
  else if (40 <= age && age < 60)
    if (75000 <= salary && salary <= 100000)
      group = GRP0;
    else if (100000 <= salary && salary <= 125000)
      group = GRP1;
    else if (125000 <= salary && salary <= 150000)
      group = GRP2;
    else if (50000 <= salary && salary <= 75000)
      group = GRP3;
    else
      group = GRP4;
 
  else
    if (100000 <= salary && salary <= 125000)
      group = GRP0;
    else if (125000 <= salary && salary <= 150000)
      group = GRP1;
    else if (50000 <= salary && salary <= 75000)
      group = GRP2;
    else if (75000 <= salary && salary <= 100000)
      group = GRP3;
    else
      group = GRP4;
 
  return (group);
}
 
 
LINT pred52(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (ed_level == 0)
      group = GRP0;
    else if (ed_level == 1)
      group = GRP1;
    else if (ed_level == 2)
      group = GRP2;
    else if (ed_level == 3)
      group = GRP3;
    else
      group = GRP4;
 
  else if (40 <= age && age < 60)
    if (ed_level == 1)
      group = GRP0;
    else if (ed_level == 2)
      group = GRP1;
    else if (ed_level == 3)
      group = GRP2;
    else if (ed_level == 4)
      group = GRP3;
    else
      group = GRP4;
 
  else
    if (ed_level == 2)
      group = GRP0;
    else if (ed_level == 3)
      group = GRP1;
    else if (ed_level == 4)
      group = GRP2;
    else if (ed_level == 0)
      group = GRP3;
    else
      group = GRP4;
 
  return (group);
}
 
 
LINT pred53(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (ed_level == 0 || ed_level == 1)
      if (50000 <= salary && salary <= 75000)
        group = GRP0;
      else if (75000 <= salary && salary <= 100000)
        group = GRP1;
      else if (100000 <= salary && salary <= 125000)
        group = GRP2;
      else if (125000 <= salary && salary <= 150000)
        group = GRP3;
      else
        group = GRP4;
    else
      if (75000 <= salary && salary <= 100000)
        group = GRP0;
      else if (100000 <= salary && salary <= 125000)
        group = GRP1;
      else if (125000 <= salary && salary <= 150000)
        group = GRP2;
      else if (50000 <= salary && salary <= 75000)
        group = GRP3;
      else
        group = GRP4;
 
  else if (40 <= age && age < 60)
    if (ed_level == 1 || ed_level == 2 || ed_level == 3 )
      if (100000 <= salary && salary <= 125000)
        group = GRP0;
      else if (125000 <= salary && salary <= 150000)
        group = GRP1;
      else if (50000 <= salary && salary <= 75000)
        group = GRP2;
      else if (75000 <= salary && salary <= 100000)
        group = GRP3;
      else
        group = GRP4;
    else
      if (125000 <= salary && salary <= 150000)
        group = GRP0;
      else if (50000 <= salary && salary <= 75000)
        group = GRP1;
      else if (75000 <= salary && salary <= 100000)
        group = GRP2;
      else if (100000 <= salary && salary <= 125000)
        group = GRP3;
      else
        group = GRP4;
 
  else
    if (ed_level == 2 || ed_level == 3 || ed_level == 4)
      if (20000 <= salary && salary <= 40000)
        group = GRP0;
      else if (40000 <= salary && salary <= 60000)
        group = GRP1;
      else if (60000 <= salary && salary <= 80000)
        group = GRP2;
      else if (80000 <= salary && salary <= 100000)
        group = GRP3;
      else
        group = GRP4;
    else
      if (40000 <= salary && salary <= 60000)
        group = GRP0;
      else if (60000 <= salary && salary <= 80000)
        group = GRP1;
      else if (80000 <= salary && salary <= 100000)
        group = GRP2;
      else if (20000 <= salary && salary <= 40000)
        group = GRP3;
      else
        group = GRP4;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *    (2*(salary+commission)/3 - ed_level*5000 - 10000);
 */
LINT pred54(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - ed_level*5000 - 20000);
  behav = disposable;
 
  if (behav > 45000)
    group = GRP0;
  else if (behav > 30000)
    group = GRP1;
  else if (behav > 15000)
    group = GRP2;
  else if (behav > 0)
    group = GRP3;
  else
    group = GRP4;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *    (2*(salary+commission)/3 - ed_level*5000 - loan/5 - 10000);
 */
LINT pred55(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - ed_level*5000 - loan/5 - 10000);
  behav = disposable;
 
  if (behav > 45000)
    group = GRP0;
  else if (behav > 30000)
    group = GRP1;
  else if (behav > 15000)
    group = GRP2;
  else if (behav > 0)
    group = GRP3;
  else
    group = GRP4;
 
  return (group);
}
 
 
LINT pred56(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  if (age < 40)
    if (50000 <= total_salary && total_salary <= 75000)
      group = GRP0;
    else if (75000 <= total_salary && total_salary <= 100000)
      group = GRP1;
    else if (100000 <= total_salary && total_salary <= 125000)
      group = GRP2;
    else if (125000 <= total_salary && total_salary <= 150000)
      group = GRP3;
    else
      group = GRP4;
 
  else if (40 <= age && age < 60)
    if (75000 <= total_salary && total_salary <= 100000)
      group = GRP0;
    else if (100000 <= total_salary && total_salary <= 125000)
      group = GRP1;
    else if (125000 <= total_salary && total_salary <= 150000)
      group = GRP2;
    else if (50000 <= total_salary && total_salary <= 75000)
      group = GRP3;
    else
      group = GRP4;
 
  else
    if (100000 <= total_salary && total_salary <= 125000)
      group = GRP0;
    else if (125000 <= total_salary && total_salary <= 150000)
      group = GRP1;
    else if (50000 <= total_salary && total_salary <= 75000)
      group = GRP2;
    else if (75000 <= total_salary && total_salary <= 100000)
      group = GRP3;
    else
      group = GRP4;
 
  return (group);
}
 
 
/* Target Audience is People with Propensity to Spend
 *
 * disposable income =
 *   (2*(salary+commission)/3 - loan/5 - ed_level*5000 + equity/5 - 10000);
 */
LINT pred57(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - loan/5 - ed_level*5000 + equity/5 - 10000);
  behav = disposable;
 
  if (behav > 45000)
    group = GRP0;
  else if (behav > 30000)
    group = GRP1;
  else if (behav > 15000)
    group = GRP2;
  else if (behav > 0)
    group = GRP3;
  else
    group = GRP4;
 
  return (group);
}
 
 
LINT pred70(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (25000 <= salary && salary <=  75000)
      group = GRP0;
    else
      group = GRP1;
 
  else if (40 <= age && age < 60)
    if (50000 <= salary && salary <= 100000)
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (75000 <= salary && salary <= 125000)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
LINT pred71(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (age < 40)
    if (75000 <= salary && salary <= 125000)
      group = GRP0;
    else
      group = GRP1;
 
  else if (40 <= age && age < 60)
    if (25000 <= salary && salary <=  75000)
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (50000 <= salary && salary <= 100000)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
LINT pred72(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (homeyears < 10)
    if (125000 <= loan && loan <= 375000)
      group = GRP0;
    else
      group = GRP1;
 
  else if (10 <= homeyears && homeyears < 20)
    if (250000 <= loan && loan <= 500000)
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (    0 <= loan && loan <= 250000)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
LINT pred73(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (homeyears < 10)
    if (0 <= loan && loan <= 250000)
      group = GRP0;
    else
      group = GRP1;
 
  else if (10 <= homeyears && homeyears < 20)
    if (125000 <= loan && loan <=  375000)
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (250000 <= loan && loan <= 500000)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
LINT pred74(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  LINT group = 0;
 
  if (homeyears < 10)
    if (115384.61 <= loan && loan <= 307692.46)
      group = GRP0;
    else
      group = GRP1;
 
  else if (10 <= homeyears && homeyears < 20)
    if ( 211538.46 <= loan && loan <= 403846.15)
      group = GRP0;
    else
      group = GRP1;
 
  else
    if (19230.77 <= loan && loan <= 211538.46)
      group = GRP0;
    else
      group = GRP1;
 
  return (group);
}
 
 
 
 
/* Modifed 25 after dropping ed_level (RA: 2/29/92)
 *
 * disposable income =
 * 25    (2*(salary+commission)/3 - ed_level*5000 - loan/5 - 10000);
 * 95    (2*(salary+commission)/3 - ed_level*0    - loan/5 - 10000);
 */
LINT pred95(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - ed_level*0 - loan/5 - 10000);
  behav = disposable;
 
  if (behav > 0)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}
 
/* Modifed 27 after dropping ed_level (RA: 2/29/92)
 *
 * disposable income =
 * 27:   (2*(salary+commission)/3 - loan/5 - ed_level*5000 + equity/5 - 10000);
 * 97:   (2*(salary+commission)/3 - loan/5 - ed_level*0    + equity/5 - 10000);
 */
LINT pred97(DOUBLE noise,
            DOUBLE salary,
            DOUBLE commission,
            LINT age,
            LINT car_model,
            LINT ed_level,
            LINT town,
            LINT homeyears,
            DOUBLE houseval,
            DOUBLE equity,
            DOUBLE loan
            )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable, behav;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable =
    (2*total_salary/3 - loan/5 - ed_level*0 + equity/5 - 10000);
  behav = disposable;
 
  if (behav > 0)
    group = GRP0;
  else
    group = GRP1;
 
  return (group);
}





/* manish 6/26/95
 *
 * predicate for 4 classes defined by 2 linear functions
 *
 * f1:  (2*(salary+commission)/3 - loan/0.2 + equity/0.2 - 10000);
 * f2:  (2*(salary+commission)/3 - loan/0.2 - equity/0.2 - 10000);
 * 
 * 
 * 
 */
LINT pred100(DOUBLE noise,
             DOUBLE salary,
             DOUBLE commission,
             LINT age,
             LINT car_model,
             LINT ed_level,
             LINT town,
             LINT homeyears,
             DOUBLE houseval,
             DOUBLE equity,
             DOUBLE loan
             )
{
  DOUBLE r_behavior = rand_Double();
  DOUBLE disposable1, disposable2, behav1, behav2;
  LINT group = 0;
  DOUBLE total_salary = salary + commission;
 
  disposable1 =
    (2 * total_salary / 3 - loan/5.0 + equity/5.0 - 10000);
  disposable2 =
    (total_salary -  loan/3.0 + equity/3.0 - 10000);
  behav1 = disposable1;
  behav2 = disposable2;
 
  if ((behav1 > 0) && (behav2 > 0)) 
    group = GRP0;
  else if ((behav1 > 0) && (behav2 < 0)) 
    group = GRP1;
  else if ((behav1 < 0) && (behav2 > 0)) 
    group = GRP2;
  else if ((behav1 < 0) && (behav2 < 0)) 
    group = GRP3;
 
  return (group);
}

/* manish 6/29/95
 *
 * predicate for assigining points to variable number of classes
 *
 */

#define NUMCELLS 150
int Group[NUMCELLS];

void assignClasses() {
  BOOLEAN done[NUMCELLS] = {FALSE}, found;
  int doneCells = 0, i, cell, class;

  class = 0;
  while(doneCells < NUMCELLS) {
      found = FALSE;
      while(!found) {
          cell = round(rand_Double() * (NUMCELLS - 1));
          if (!done[cell]) {
              Group[cell] = class;
              found = TRUE;
              done[cell] = TRUE;
          }
      }
      doneCells++;
      class++;
      if (class == groups) class = 0;
  }
}

LINT pred101(DOUBLE noise,
             DOUBLE salary,
             DOUBLE commission,
             LINT age,
             LINT car_model,
             LINT ed_level,
             LINT town,
             LINT homeyears,
             DOUBLE houseval,
             DOUBLE equity,
             DOUBLE loan
             )
{
  int ageIndex, salaryIndex, loanIndex;
  
  if (age <= 30)
    ageIndex = 0;
  else if (age <= 40)
    ageIndex = 1;
 if (age <= 50)
    ageIndex = 2;
 if (age <= 60)
    ageIndex = 3;
 if (age <= 70)
    ageIndex = 4;
  else
    ageIndex = 5;
  
  if (salary <= 30000)
    salaryIndex = 0;
  else if (salary <= 60000)
    salaryIndex = 1;
  else if (salary <= 90000)
    salaryIndex = 2;
  else if (salary <= 120000)
    salaryIndex = 3;
  else
    salaryIndex = 4;
  
  if (loan <= 100000)
    loanIndex = 0;
  else if (loan <= 200000)
    loanIndex = 1;
  else if (loan <= 300000)
    loanIndex = 2;
  else if (loan <= 400000)
    loanIndex = 3;
  else
    loanIndex = 4;
  
  return (Group[ageIndex * 5 * 5 + salaryIndex * 5 + loanIndex]);
}

