#define US 1
#undef USA
 
#ifdef US
#undef c4
#endif
 
#ifdef c4
#undef US
#endif
 
#undef EXAMPLE

#include "global.h"
#include "functions.h"

#include "Python.h"
 
static PyObject *generate(PyObject *self, PyObject *args);

/* #### Globals #################################### */

/* ==== Set up the methods table ====================== */
static PyMethodDef _struct_generator_func[] = {
  {"generate", generate, METH_VARARGS},
  {NULL, NULL}     /* Sentinel - marks the end of this structure */
};

/* ==== Initialize functions ====================== */
PyMODINIT_FUNC init_struct_generator()
{
  (void) Py_InitModule("_struct_generator", _struct_generator_func);
}



/* Proposed changes
 * Generate two tuples one with all the low values of all the attributes,
 *   the other with all the high values of all the attributes.
 *   The group assignment for these are (arbitrarily) 0 and 1.
 */
 
 
/* For different predicate functions */
typedef LINT (*Predicate_Func)(DOUBLE noise,
                               DOUBLE salary,
                               DOUBLE commission,
                               LINT age,
                               LINT car_model,
                               LINT ed_level,
                               LINT town,
                               LINT homeyears,
                               DOUBLE housevalue,
                               DOUBLE equity,
                               DOUBLE loan
                               );
 
typedef Predicate_Func Predicate_Func_List[NO_PRED_FUNCS];
 
Predicate_Func_List pred_funcs;
 
/* Call to a single predicate function */
#define pred(pred_func_no, \
             noise, salary, commission, age, \
             car_model, ed_level, town, homeyears, \
             houseval, equity, loan) \
(pred_funcs[pred_func_no])(noise, salary, commission, age, \
                              car_model,ed_level, town, homeyears, \
                              houseval, equity, loan)
 
 
/* Inital random seeds */
LINT rseeds[MAX_SEEDS];
 
/* Only generate group fractions */
BOOLEAN gen_grp_frac = FALSE;
 
/* How much perturbation */
FLOAT perturb_frac = 0.0;
 
/* Generate pert file */
BOOLEAN gen_pert_file = FALSE;
FILE* pert_file = 0;
 
/* Generate test file */
BOOLEAN gen_test_file = FALSE;
 
/* Generate self test file */
BOOLEAN gen_self_file = FALSE;
 
/* Noise in data generation */
DOUBLE noise = 0;
 
/* Number of groups */
LINT groups = 2;
 
/* Number of attributes */
LINT attributes = 9,
     numAtts = 9;
 
/* Predicate function */
LINT pred_func_no = 1;
 
/* Group 0 fraction */
FLOAT g0_frac = 0;
FLOAT g1_frac = 0;
FLOAT g2_frac = 0;

 
 
 
LINT code(LINT townnum) {
    return (townnum);
}
 
 
LINT gen_Data_File(LINT initial_seed,
                   LINT num_tuples,
                   PyObject *writer_func
                   )
{
  LINT ret_code;                /* Return code */
  LINT i, attNum;
  LINT num_gen;
  LINT grp_number[MAX_GROUPS];
  LINT grp_limit[MAX_GROUPS];
  LINT gen_limit;
  BOOLEAN next;
  LINT group, new_group;
  LINT err_cnt;
  DOUBLE rsal, rcom1, rcom2, rage, rtown, rhval, ryears, rchild, rloan, red;
  DOUBLE salary, commission, houseval, equity, loan;
  DOUBLE rsald, rcomd, rloand, raged, ryearsd, rhvald; /*Bala 1/30/91 */
  LINT age, ed_level, car_model, homeyears, town;


  PyObject *list, *res, *item;
 
  randomize(rseeds[initial_seed]);
  err_cnt = 0;
 
  for (i = 0; i < groups; ++i) {
    grp_number[i] = 0;
  }

  if (pred_func_no == 101) {
    for(i = 0; i < groups - 1; i++) {
      grp_limit[i] = (LINT)(num_tuples / groups);
    }
    grp_limit[groups - 1] = num_tuples - (groups - 1) * grp_limit[0];
  } else
  if (groups == 2) {
    grp_limit[0] = (LINT)(g0_frac * num_tuples);
    grp_limit[1] = num_tuples - grp_limit[0];
  } else if (groups == 4) {
    grp_limit[0] = (LINT)(g0_frac * num_tuples);
    grp_limit[1] = (LINT)(g1_frac * num_tuples);
    grp_limit[2] = (LINT)(g2_frac * num_tuples);
    grp_limit[3] = num_tuples - grp_limit[0] - grp_limit[1] - grp_limit[2];
  }
  if (num_tuples < 100000000)
    gen_limit = 40 * num_tuples;
  else
    gen_limit = 400 * num_tuples;
 
 
  /*
   * Generate two tuples one with all the low values of all the attributes,
   *   the other with all the high values of all the attributes.
   *   The group assignment for these are (arbitrarily) 0 and 1.
   */
  /*
   * group, salary, commission, loan, age, code(town),
   * homeyears, houseval, ed_level, car_model
   */
  num_gen = 0;
  for (i = 0; (i < num_tuples) && (num_gen < gen_limit); i++) {
    next = TRUE;
    while (next) {
      num_gen++;
 
      rsal = rand_Double();
      rcom1 = rand_Double();
      rcom2 = rand_Double();
      rage = rand_Double();
      rtown = rand_Double();
      rhval = rand_Double();
      ryears = rand_Double();
      rchild = rand_Double();
      rloan  = rand_Double();
      red  = rand_Double();
 
      salary = 20000 + 130000*rsal;
 
      if (rcom1 < 0.5 && salary < 75000)
        commission = 10000 + 65000 * rcom2;
      else
        commission = 0;
 
      age = 20 + round(rage*60);
      town = round(rtown * 9);
      houseval = (9.0-town) * 100000 * (.5 + rhval);
      homeyears = round(ryears * 30);
      if (homeyears < 20)
        equity = 0;
      else
        equity = houseval*(homeyears - 20)/10.0;
      ed_level = round(rchild * 4);
      loan = rloan * 500000;
      car_model = round(red * 19);

      group = pred_funcs[pred_func_no](noise, salary, commission, age,
                   car_model, ed_level, town, homeyears,
                   houseval, equity, loan);

      if (grp_number[group] < grp_limit[group]) {
        grp_number[group]++;
        next = FALSE;
      }
    }    /* while (next) */
 
    rsald = 2.0 *(rand_Double()-0.5);
    rcomd = 2.0 *(rand_Double()-0.5);
    rloand = 2.0 *(rand_Double()-0.5);
    raged  = 2.0 *(rand_Double()-0.5);
    ryearsd = 2.0 *(rand_Double()-0.5);
    rhvald  = 2.0 *(rand_Double()-0.5);
    
    salary += (130000-20000)*rsald*perturb_frac;
    if (salary < 20000) {
      salary = 20000;
    }
    else if (salary > 150000) {
      salary = 150000;
    }
    
    if (commission > 0) {
      commission += (75000-10000)*rcomd*perturb_frac;
      if (commission < 10000) {
        commission = 10000;
      }
      else if (commission > 75000) {
        commission = 75000;
      }
    }
    
    loan += (500000 - 0)*rloand*perturb_frac;
    if (loan < 0) {
      loan = 0;
    }
    else if (loan > 500000) {
      loan = 500000;
    }
    
    age += round((80 - 20)*raged*perturb_frac);
    if (age < 20) {
      age = 20;
    }
    else if (age > 80) {
      age = 80;
    }
    
    homeyears += round((30 - 0)*ryearsd*perturb_frac);
    if (homeyears < 0) {
      homeyears = 0;
    }
    else if (homeyears > 30) {
      homeyears = 30;
    }
    
    houseval += (9.0-town)*100000*rhvald*perturb_frac;
    if (houseval < 0) {
      houseval = 0;
    }
    else if (houseval > 1350000) {
      houseval = 1350000;
    }
    
    if (gen_pert_file) {
      new_group =
        pred_funcs[pred_func_no](noise, salary, commission, age,
                                 car_model, ed_level, town, homeyears,
                                 houseval, equity, loan);
      if (new_group != group) {
        err_cnt++;
      }
    }

    if (!gen_grp_frac) {
      list = Py_BuildValue("[fffiiifii]", salary, commission, loan, age, code(town), homeyears,
			   houseval, ed_level, car_model);
      
        /* add randomly distributed attributes to the file */
      for (attNum = 9; attNum < numAtts; attNum++) {
	item = PyFloat_FromDouble(rand_Double() * 100000);
	PyList_Append(list, item);
	Py_XDECREF(item);
      }
      item = PyInt_FromLong(group + 1);
      PyList_Append(list, item);
      Py_XDECREF(item);
      
      res = PyObject_CallFunction(writer_func, "O", list);
      Py_XDECREF(list);
      Py_XDECREF(res);
    }
  }
 
  if (num_gen >= gen_limit) {
    ret_code = 1;
    goto finish;
  }
 
  ret_code = 0;
 
 finish:
  return (ret_code);
}
 
static PyObject *generate(PyObject *self, PyObject *args) {
  
  LINT ret_code;                /* Return code */
  LINT nseed = SEED;
  LINT tuples = 1000;

  PyObject* write_func;

  if (!PyArg_ParseTuple(args, "iiiififfffiO", 
			&tuples, &groups, &numAtts, &nseed, &noise, &pred_func_no,
			&g0_frac,&g1_frac,&g2_frac, &perturb_frac, &gen_grp_frac,
			&write_func)){
    return NULL;
  }

  if(NULL == write_func || !PyCallable_Check(write_func)) {
      PyErr_SetString(PyExc_TypeError, "the 12-th parameter must be callable");
      return NULL;
  }
 
  /* Initialize predicate functions */ 
  pred_funcs[0] = (Predicate_Func)(pred0);
  pred_funcs[1] = (Predicate_Func)(pred1);
  pred_funcs[2] = (Predicate_Func)(pred2);
  pred_funcs[3] = (Predicate_Func)(pred3);
  pred_funcs[4] = (Predicate_Func)(pred4);
  pred_funcs[5] = (Predicate_Func)(pred5);
  pred_funcs[6] = (Predicate_Func)(pred6);
  pred_funcs[7] = (Predicate_Func)(pred7);
  pred_funcs[8] = (Predicate_Func)(pred8);
  pred_funcs[9] = (Predicate_Func)(pred9);
  pred_funcs[10] = (Predicate_Func)(pred10);
 
  pred_funcs[20] = (Predicate_Func)(pred20);
  pred_funcs[21] = (Predicate_Func)(pred21);
  pred_funcs[22] = (Predicate_Func)(pred22);
  pred_funcs[23] = (Predicate_Func)(pred23);
  pred_funcs[24] = (Predicate_Func)(pred24);
  pred_funcs[25] = (Predicate_Func)(pred25);
  pred_funcs[26] = (Predicate_Func)(pred26);
  pred_funcs[27] = (Predicate_Func)(pred27);
  pred_funcs[28] = (Predicate_Func)(pred28);
  pred_funcs[29] = (Predicate_Func)(pred29);
  pred_funcs[60] = (Predicate_Func)(pred60);
 
  pred_funcs[30] = (Predicate_Func)(pred30);
  pred_funcs[31] = (Predicate_Func)(pred31);
  pred_funcs[32] = (Predicate_Func)(pred32);
  pred_funcs[33] = (Predicate_Func)(pred33);
  pred_funcs[34] = (Predicate_Func)(pred34);
  pred_funcs[35] = (Predicate_Func)(pred35);
  pred_funcs[36] = (Predicate_Func)(pred36);
  pred_funcs[37] = (Predicate_Func)(pred37);
 
  pred_funcs[40] = (Predicate_Func)(pred40);
  pred_funcs[41] = (Predicate_Func)(pred41);
  pred_funcs[42] = (Predicate_Func)(pred42);
  pred_funcs[43] = (Predicate_Func)(pred43);
  pred_funcs[44] = (Predicate_Func)(pred44);
  pred_funcs[45] = (Predicate_Func)(pred45);
  pred_funcs[46] = (Predicate_Func)(pred46);
  pred_funcs[47] = (Predicate_Func)(pred47);
 
  pred_funcs[50] = (Predicate_Func)(pred50);
  pred_funcs[51] = (Predicate_Func)(pred51);
  pred_funcs[52] = (Predicate_Func)(pred52);
  pred_funcs[53] = (Predicate_Func)(pred53);
  pred_funcs[54] = (Predicate_Func)(pred54);
  pred_funcs[55] = (Predicate_Func)(pred55);
  pred_funcs[56] = (Predicate_Func)(pred56);
  pred_funcs[57] = (Predicate_Func)(pred57);
 
  pred_funcs[70] = (Predicate_Func)(pred70);
  pred_funcs[71] = (Predicate_Func)(pred71);
  pred_funcs[72] = (Predicate_Func)(pred72);
  pred_funcs[73] = (Predicate_Func)(pred73);
  pred_funcs[74] = (Predicate_Func)(pred74);
 
 
  pred_funcs[95] = (Predicate_Func)(pred95);
  pred_funcs[97] = (Predicate_Func)(pred97);

  pred_funcs[100] = (Predicate_Func)(pred100);
  pred_funcs[101] = (Predicate_Func)(pred101);
 
  init_seeds(rseeds);
  randomize(rseeds[nseed]);


  if (pred_func_no == 101) assignClasses();

  ret_code = gen_Data_File(nseed, tuples, write_func);
 
  if (ret_code == 1) {
    PyErr_SetString(PyExc_RuntimeError, "Specified fraction too hard to generate");
    return NULL;
  }
 
  Py_RETURN_NONE;
}
